---
title: Update a User Agent Blocking rule
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[Firewall](https://developers.cloudflare.com/api/go/resources/firewall)

[UA Rules](https://developers.cloudflare.com/api/go/resources/firewall/subresources/ua_rules)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Update a User Agent Blocking rule

client.Firewall.UARules.Update(ctx, uaRuleID, params) (\*[UARuleUpdateResponse](<https://developers.cloudflare.com/api/go/resources/firewall#(resource)%20firewall.ua_rules%20%3E%20(model)%20UARuleUpdateResponse%20%3E%20(schema)>), error)

PUT/zones/{zone\_id}/firewall/ua\_rules/{ua\_rule\_id}

Updates an existing User Agent Blocking rule.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Firewall Services Write`

##### ParametersExpand Collapse

uaRuleID string

The unique identifier of the User Agent Blocking rule.

maxLength32

[Link to this property](<#(resource)%20firewall.ua_rules%20%3E%20(method)%20update%20%3E%20(params)%20default%20%3E%20(param)%20ua_rule_id%20%3E%20(schema)>)

<details>

<summary>

params UARuleUpdateParams

</summary>

ZoneID param.Field\[string]

Path param: Defines an identifier.

maxLength32

<a href="#(resource)%20firewall.ua_rules%20%3E%20(method)%20update%20%3E%20(params)%20default%20%3E%20(param)%20zone_id">Link to this property</a>

<details>

<summary>

Configuration param.Field\[<a href="https://developers.cloudflare.com/api/go/resources/firewall/subresources/ua_rules/methods/update#(resource)%20firewall.ua_rules%20%3E%20(method)%20update%20%3E%20(params)%20default%20%3E%20(param)%20configuration%20%3E%20(schema)">UARuleUpdateParamsConfiguration</a>]

Body param: The rule configuration.

</summary>

<details>

<summary>

type AccessRuleIPConfiguration struct{…}

</summary>

Target AccessRuleIPConfigurationTargetOptional

The configuration target. You must set the target to <code>ip</code> when specifying an IP address in the rule.

<a href="#(resource)%20firewall.access_rules%20%3E%20(model)%20access_rule_ip_configuration%20%3E%20(schema)%20%3E%20(property)%20target">Link to this property</a>

Value stringOptional

The IP address to match. This address will be compared to the IP address of incoming requests.

<a href="#(resource)%20firewall.access_rules%20%3E%20(model)%20access_rule_ip_configuration%20%3E%20(schema)%20%3E%20(property)%20value">Link to this property</a>

</details>

<a href="#(resource)%20firewall.access_rules%20%3E%20(model)%20access_rule_ip_configuration%20%3E%20(schema)">Link to this property</a>

<details>

<summary>

type IPV6Configuration struct{…}

</summary>

Target IPV6ConfigurationTargetOptional

The configuration target. You must set the target to <code>ip6</code> when specifying an IPv6 address in the rule.

<a href="#(resource)%20firewall.access_rules%20%3E%20(model)%20ipv6_configuration%20%3E%20(schema)%20%3E%20(property)%20target">Link to this property</a>

Value stringOptional

The IPv6 address to match.

<a href="#(resource)%20firewall.access_rules%20%3E%20(model)%20ipv6_configuration%20%3E%20(schema)%20%3E%20(property)%20value">Link to this property</a>

</details>

<a href="#(resource)%20firewall.access_rules%20%3E%20(model)%20ipv6_configuration%20%3E%20(schema)">Link to this property</a>

<details>

<summary>

type AccessRuleCIDRConfiguration struct{…}

</summary>

Target AccessRuleCIDRConfigurationTargetOptional

The configuration target. You must set the target to <code>ip_range</code> when specifying an IP address range in the rule.

<a href="#(resource)%20firewall.access_rules%20%3E%20(model)%20access_rule_cidr_configuration%20%3E%20(schema)%20%3E%20(property)%20target">Link to this property</a>

Value stringOptional

The IP address range to match. You can only use prefix lengths <code>/16</code> and <code>/24</code> for IPv4 ranges, and prefix lengths <code>/32</code>, <code>/48</code>, and <code>/64</code> for IPv6 ranges.

<a href="#(resource)%20firewall.access_rules%20%3E%20(model)%20access_rule_cidr_configuration%20%3E%20(schema)%20%3E%20(property)%20value">Link to this property</a>

</details>

<a href="#(resource)%20firewall.access_rules%20%3E%20(model)%20access_rule_cidr_configuration%20%3E%20(schema)">Link to this property</a>

<details>

<summary>

type ASNConfiguration struct{…}

</summary>

Target ASNConfigurationTargetOptional

The configuration target. You must set the target to <code>asn</code> when specifying an Autonomous System Number (ASN) in the rule.

<a href="#(resource)%20firewall.access_rules%20%3E%20(model)%20asn_configuration%20%3E%20(schema)%20%3E%20(property)%20target">Link to this property</a>

Value stringOptional

The AS number to match.

<a href="#(resource)%20firewall.access_rules%20%3E%20(model)%20asn_configuration%20%3E%20(schema)%20%3E%20(property)%20value">Link to this property</a>

</details>

<a href="#(resource)%20firewall.access_rules%20%3E%20(model)%20asn_configuration%20%3E%20(schema)">Link to this property</a>

<details>

<summary>

type CountryConfiguration struct{…}

</summary>

Target CountryConfigurationTargetOptional

The configuration target. You must set the target to <code>country</code> when specifying a country code in the rule.

<a href="#(resource)%20firewall.access_rules%20%3E%20(model)%20country_configuration%20%3E%20(schema)%20%3E%20(property)%20target">Link to this property</a>

Value stringOptional

The two-letter ISO-3166-1 alpha-2 code to match. For more information, refer to <a href="https://developers.cloudflare.com/waf/tools/ip-access-rules/parameters/#country">IP Access rules: Parameters</a>.

<a href="#(resource)%20firewall.access_rules%20%3E%20(model)%20country_configuration%20%3E%20(schema)%20%3E%20(property)%20value">Link to this property</a>

</details>

<a href="#(resource)%20firewall.access_rules%20%3E%20(model)%20country_configuration%20%3E%20(schema)">Link to this property</a>

</details>

<a href="#(resource)%20firewall.ua_rules%20%3E%20(method)%20update%20%3E%20(params)%20default%20%3E%20(param)%20configuration">Link to this property</a>

<details>

<summary>

Mode param.Field\[<a href="https://developers.cloudflare.com/api/go/resources/firewall/subresources/ua_rules/methods/update#(resource)%20firewall.ua_rules%20%3E%20(method)%20update%20%3E%20(params)%20default%20%3E%20(param)%20mode%20%3E%20(schema)">UARuleUpdateParamsMode</a>]

Body param: The action to apply to a matched request.

</summary>

const UARuleUpdateParamsModeBlock <a href="https://developers.cloudflare.com/api/go/resources/firewall/subresources/ua_rules/methods/update#(resource)%20firewall.ua_rules%20%3E%20(method)%20update%20%3E%20(params)%20default%20%3E%20(param)%20mode%20%3E%20(schema)">UARuleUpdateParamsMode</a> = "block"

<a href="#(resource)%20firewall.ua_rules%20%3E%20(method)%20update%20%3E%20(params)%20default%20%3E%20(param)%20mode%20%3E%20(schema)%20%3E%20(member)%200">Link to this property</a>

const UARuleUpdateParamsModeChallenge <a href="https://developers.cloudflare.com/api/go/resources/firewall/subresources/ua_rules/methods/update#(resource)%20firewall.ua_rules%20%3E%20(method)%20update%20%3E%20(params)%20default%20%3E%20(param)%20mode%20%3E%20(schema)">UARuleUpdateParamsMode</a> = "challenge"

<a href="#(resource)%20firewall.ua_rules%20%3E%20(method)%20update%20%3E%20(params)%20default%20%3E%20(param)%20mode%20%3E%20(schema)%20%3E%20(member)%201">Link to this property</a>

const UARuleUpdateParamsModeWhitelist <a href="https://developers.cloudflare.com/api/go/resources/firewall/subresources/ua_rules/methods/update#(resource)%20firewall.ua_rules%20%3E%20(method)%20update%20%3E%20(params)%20default%20%3E%20(param)%20mode%20%3E%20(schema)">UARuleUpdateParamsMode</a> = "whitelist"

<a href="#(resource)%20firewall.ua_rules%20%3E%20(method)%20update%20%3E%20(params)%20default%20%3E%20(param)%20mode%20%3E%20(schema)%20%3E%20(member)%202">Link to this property</a>

const UARuleUpdateParamsModeJSChallenge <a href="https://developers.cloudflare.com/api/go/resources/firewall/subresources/ua_rules/methods/update#(resource)%20firewall.ua_rules%20%3E%20(method)%20update%20%3E%20(params)%20default%20%3E%20(param)%20mode%20%3E%20(schema)">UARuleUpdateParamsMode</a> = "js\_challenge"

<a href="#(resource)%20firewall.ua_rules%20%3E%20(method)%20update%20%3E%20(params)%20default%20%3E%20(param)%20mode%20%3E%20(schema)%20%3E%20(member)%203">Link to this property</a>

const UARuleUpdateParamsModeManagedChallenge <a href="https://developers.cloudflare.com/api/go/resources/firewall/subresources/ua_rules/methods/update#(resource)%20firewall.ua_rules%20%3E%20(method)%20update%20%3E%20(params)%20default%20%3E%20(param)%20mode%20%3E%20(schema)">UARuleUpdateParamsMode</a> = "managed\_challenge"

<a href="#(resource)%20firewall.ua_rules%20%3E%20(method)%20update%20%3E%20(params)%20default%20%3E%20(param)%20mode%20%3E%20(schema)%20%3E%20(member)%204">Link to this property</a>

</details>

<a href="#(resource)%20firewall.ua_rules%20%3E%20(method)%20update%20%3E%20(params)%20default%20%3E%20(param)%20mode">Link to this property</a>

Description param.Field\[string]Optional

Body param: An informative summary of the rule. This value is sanitized and any tags will be removed.

maxLength1024

<a href="#(resource)%20firewall.ua_rules%20%3E%20(method)%20update%20%3E%20(params)%20default%20%3E%20(param)%20description">Link to this property</a>

Paused param.Field\[bool]Optional

Body param: When true, indicates that the rule is currently paused.

<a href="#(resource)%20firewall.ua_rules%20%3E%20(method)%20update%20%3E%20(params)%20default%20%3E%20(param)%20paused">Link to this property</a>

</details>

[Link to this property](<#(resource)%20firewall.ua_rules%20%3E%20(method)%20update%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

type UARuleUpdateResponse struct{…}

</summary>

ID stringOptional

The unique identifier of the User Agent Blocking rule.

maxLength32

<a href="#(resource)%20firewall.ua_rules%20%3E%20(model)%20UARuleUpdateResponse%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

<details>

<summary>

Configuration UARuleUpdateResponseConfigurationOptional

The configuration object for the current rule.

</summary>

Target stringOptional

The configuration target for this rule. You must set the target to <code>ua</code> for User Agent Blocking rules.

<a href="#(resource)%20firewall.ua_rules%20%3E%20(model)%20UARuleUpdateResponse%20%3E%20(schema)%20%3E%20(property)%20configuration%20%3E%20(property)%20target">Link to this property</a>

Value stringOptional

The exact user agent string to match. This value will be compared to the received <code>User-Agent</code> HTTP header value.

<a href="#(resource)%20firewall.ua_rules%20%3E%20(model)%20UARuleUpdateResponse%20%3E%20(schema)%20%3E%20(property)%20configuration%20%3E%20(property)%20value">Link to this property</a>

</details>

<a href="#(resource)%20firewall.ua_rules%20%3E%20(model)%20UARuleUpdateResponse%20%3E%20(schema)%20%3E%20(property)%20configuration">Link to this property</a>

Description stringOptional

An informative summary of the rule.

maxLength1024

<a href="#(resource)%20firewall.ua_rules%20%3E%20(model)%20UARuleUpdateResponse%20%3E%20(schema)%20%3E%20(property)%20description">Link to this property</a>

<details>

<summary>

Mode UARuleUpdateResponseModeOptional

The action to apply to a matched request.

maxLength12

</summary>

One of the following:

const UARuleUpdateResponseModeBlock UARuleUpdateResponseMode = "block"

<a href="#(resource)%20firewall.ua_rules%20%3E%20(model)%20UARuleUpdateResponse%20%3E%20(schema)%20%3E%20(property)%20mode%20%3E%20(member)%200">Link to this property</a>

const UARuleUpdateResponseModeChallenge UARuleUpdateResponseMode = "challenge"

<a href="#(resource)%20firewall.ua_rules%20%3E%20(model)%20UARuleUpdateResponse%20%3E%20(schema)%20%3E%20(property)%20mode%20%3E%20(member)%201">Link to this property</a>

const UARuleUpdateResponseModeJSChallenge UARuleUpdateResponseMode = "js\_challenge"

<a href="#(resource)%20firewall.ua_rules%20%3E%20(model)%20UARuleUpdateResponse%20%3E%20(schema)%20%3E%20(property)%20mode%20%3E%20(member)%202">Link to this property</a>

const UARuleUpdateResponseModeManagedChallenge UARuleUpdateResponseMode = "managed\_challenge"

<a href="#(resource)%20firewall.ua_rules%20%3E%20(model)%20UARuleUpdateResponse%20%3E%20(schema)%20%3E%20(property)%20mode%20%3E%20(member)%203">Link to this property</a>

</details>

<a href="#(resource)%20firewall.ua_rules%20%3E%20(model)%20UARuleUpdateResponse%20%3E%20(schema)%20%3E%20(property)%20mode">Link to this property</a>

Paused boolOptional

When true, indicates that the rule is currently paused.

<a href="#(resource)%20firewall.ua_rules%20%3E%20(model)%20UARuleUpdateResponse%20%3E%20(schema)%20%3E%20(property)%20paused">Link to this property</a>

</details>

[Link to this property](<#(resource)%20firewall.ua_rules%20%3E%20(model)%20UARuleUpdateResponse%20%3E%20(schema)>)

### Update a User Agent Blocking rule

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/firewall"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  uaRule, err := client.Firewall.UARules.Update(
    context.TODO(),
    "372e67954025e0ba6aaa6d586b9e0b59",
    firewall.UARuleUpdateParams{
      ZoneID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
      Configuration: cloudflare.F[firewall.UARuleUpdateParamsConfigurationUnion](firewall.AccessRuleIPConfigurationParam{

      }),
      Mode: cloudflare.F(firewall.UARuleUpdateParamsModeChallenge),
    },
  )
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", uaRule.ID)
}
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "id": "372e67954025e0ba6aaa6d586b9e0b59",
    "configuration": {
      "target": "ua",
      "value": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_5) AppleWebKit/603.2.4 (KHTML, like Gecko) Version/10.1.1 Safari/603.2.4"
    },
    "description": "Prevent access from abusive clients identified by this User Agent to mitigate a DDoS attack",
    "mode": "js_challenge",
    "paused": false
  },
  "success": true
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "id": "372e67954025e0ba6aaa6d586b9e0b59",
    "configuration": {
      "target": "ua",
      "value": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_5) AppleWebKit/603.2.4 (KHTML, like Gecko) Version/10.1.1 Safari/603.2.4"
    },
    "description": "Prevent access from abusive clients identified by this User Agent to mitigate a DDoS attack",
    "mode": "js_challenge",
    "paused": false
  },
  "success": true
}
```